package oracle.raster.test;

import oracle.spatial.hadoop.imageprocessor.util.ProcessConstants;
import oracle.spatial.hadoop.rasterapi.core.HadoopConfiguration;
import oracle.spatial.hadoop.rasterapi.core.beans.MosaicConfiguration;
import oracle.spatial.hadoop.rasterapi.core.beans.Raster;
import oracle.spatial.hadoop.rasterapi.core.beans.RasterCatalog;
import oracle.spatial.hadoop.rasterapi.core.jobs.RasterLoaderJob;
import oracle.spatial.hadoop.rasterapi.core.jobs.RasterProcessorJob;

public class RasterExample {
    public RasterExample() {
        super();
    }
    
    public static void main(String args[]){
        HadoopConfiguration hadoopConf = new HadoopConfiguration();
        String gdalData = "/opt/oracle/oracle-spatial-graph/spatial/raster/gdal/data";
        hadoopConf.setGdalDataPath(gdalData);
        hadoopConf.setMapreduceJobJar("hadoop-imageloader.jar");

        String rasterDirectory = "/opt/oracle/oracle-spatial-graph/spatial/raster/Raster-HOL/data/raster/hawaii.tif,/opt/oracle/oracle-spatial-graph/spatial/raster/Raster-HOL/data/raster/kahoolawe.tif,/opt/oracle/oracle-spatial-graph/spatial/raster/Raster-HOL/data/raster/maui.tif";

                                        RasterLoaderJob loader = (RasterLoaderJob) hadoopConf.createRasterLoaderJob();
        loader.setFilesToLoad(rasterDirectory);
        loader.setOutputFolder("exercise4");
        loader.setRasterThumbnailFolder("/opt/shareddir/spatial");
        loader.setTileOverlap("50");
        String gdalDirectory = "/opt/oracle/oracle-spatial-graph/spatial/raster/gdal/lib";
                
        try {
                        loader.setGdalPath(gdalDirectory);
        //Executes the job
        boolean loaderSuccess = loader.execute();

        if (loaderSuccess) {
         System.out.println("Successfully executed loader job");
            hadoopConf = new HadoopConfiguration();
            hadoopConf.setGdalDataPath(gdalData);
            hadoopConf.setMapreduceJobJar("hadoop-imageprocessor.jar");
            RasterProcessorJob processor = (RasterProcessorJob) hadoopConf.createRasterProcessorJob();
            processor.setGdalPath(gdalDirectory);
            MosaicConfiguration mosaic = new MosaicConfiguration();
            mosaic.setBands(3);
            mosaic.setDirectory("/opt/shareddir/spatial");
            mosaic.setFileName("APIMosaicFS");
            mosaic.setFileSystem(RasterProcessorJob.FS);
            mosaic.setFormat("GTIFF");
            mosaic.setSrid("26904");
            mosaic.setWidth(1600);            
            mosaic.setHeight(986);
            //byte datatype
              mosaic.setPixelType("1");
              mosaic.setNoData("#FFFFFF");
               //in case two or more rasters overlap, the area covered by the rasters will determine its priority in the mosaic
              mosaic.setOrderAlgorithm(ProcessConstants.ALGORITHM_FILE_LENGTH);
              //rasters that cover less area will be located on top of the mosaic, DESC, descending order
              mosaic.setOrder(RasterProcessorJob.DESC);
            
                     //width for pixels in X and Y
              mosaic.setPixelXWidth(280.388143);
              mosaic.setPixelYWidth(-280.388143);
              //upper left coordinates
              mosaic.setUpperLeftX(556958.985610);
              mosaic.setUpperLeftY(2350324.082505);
            RasterCatalog catalog = new RasterCatalog();

            //Creates a raster object for the catalog
            Raster raster = new Raster();
            raster.setBands(3);
            //the tree bands will appear in order 1,2, 3. You may list less bands here.
            raster.setBandsOrder("1,2,3");
            raster.setDataType(1);
            raster.setRasterLocation("/user/hdfs/exercise4/opt/oracle/oracle-spatial-graph/spatial/raster/Raster-HOL/data/raster/hawaii.tif.ohif");
            //Add raster to catalog
            catalog.addRasterToCatalog(raster);
            
           raster = new Raster();
            raster.setBands(3);
            //the tree bands will appear in order 1,2, 3. You may list less bands here.
            raster.setBandsOrder("1,2,3");
            raster.setDataType(1);
            raster.setRasterLocation("/user/hdfs/exercise4/opt/oracle/oracle-spatial-graph/spatial/raster/Raster-HOL/data/raster/kahoolawe.tif.ohif");
            //Add raster to catalog
            catalog.addRasterToCatalog(raster);
            
         raster = new Raster();
            raster.setBands(3);
            //the tree bands will appear in order 1,2, 3. You may list less bands here.
            raster.setBandsOrder("1,2,3");
            raster.setDataType(1);
            raster.setRasterLocation("/user/hdfs/exercise4/opt/oracle/oracle-spatial-graph/spatial/raster/Raster-HOL/data/raster/maui.tif.ohif");
            //Add raster to catalog
            catalog.addRasterToCatalog(raster);
            
            
            processor.setMosaicConfigurationObject(mosaic.getCompactMosaic());
            processor.setCatalogObject(catalog.getCompactCatalog());


                  
            boolean processorSuccess = processor.execute();
                     if (processorSuccess) {
                         System.out.println("Successfully executed processor job");
                     } else {
                         System.out.println("Failed to execute processor job");
                     }



        } else {
         System.out.println("Failed to execute loader job");
        }
                       } catch (Exception e) {
                    System.out.println("Problem when trying to execute raster loader " + e.getMessage());

        }
    }
}
