package hol;

import oracle.spatial.hadoop.vector.hierarchy.impl.DynaAdminHierarchyInfo;


/**
 * Subclass of DynaAdminHierarchyInfo that setups the hierarchy composed of the layers 
 * eurozone_countries and eurozone_provinces.
 *
 */
public class EuroHierarchyInfo extends DynaAdminHierarchyInfo {
	
	public EuroHierarchyInfo(){
		super();
		addLevel(
				1, //hierarchy level number
				"eurozone_countries", //hierarchy level name
				"_id", //path to the JSON field used to associate entries of this level with their children.
				null  
				);
		
		addLevel(
				2, //hierarchy level number
				"eurozone_provinces", //hierarchy level name
				null, 
				"properties.ISO" //path to the JSON field used to associate entries of this level with their parent. 
				);
	}
}
